import Dexie from "dexie";

export interface ICell {
  id?: number,
  p: object,
  s: number,
  v: string | number | boolean,
  m: string,
  f: string,
  fm: object,
  h: string,
  n: string
}

export interface IJson {
  id?: number,
  j: ICell[]
}

export interface IText {
  id?: number,
  t: string
}

export class AppDatabase extends Dexie {
  cells: Dexie.Table<ICell, number>;
  jsons: Dexie.Table<IJson, number>;
  text: Dexie.Table<IText, number>;

  public constructor() {
    super('database');
    this.version(3).stores({
      cells: '++id, p, s, v, m, f, fm, h, n',
      text: '++id, tx',
      jsons: '++id, t',
    });
  }
}
